using Gtk;
using Gdk;
using GL;

public class Simple : Gtk.Window
{

        private bool on_configure_event (Gtk.DrawingArea widget, Gdk.EventConfigure event)
        {
                Gdk.GL.Context glcontext = Gtk.GL.GtkWidgetExtension.get_gl_context (widget);
                Gdk.GL.Drawable gldrawable = Gtk.GL.GtkWidgetExtension.get_gl_drawable (widget);

                if (!gldrawable.gl_begin (glcontext))
                return false;

                glViewport (0, 0, (GLsizei)widget.allocation.width, (GLsizei)widget.allocation.height);

                gldrawable.gl_end ();
                return true;
        }

        private bool on_expose_event (Gtk.DrawingArea widget, Gdk.EventExpose event)
        {
                Gdk.GL.Context glcontext = Gtk.GL.GtkWidgetExtension.get_gl_context (widget);
                Gdk.GL.Drawable gldrawable = Gtk.GL.GtkWidgetExtension.get_gl_drawable (widget);

                if (!gldrawable.gl_begin (glcontext))
                        return false;

                glClear (GL_COLOR_BUFFER_BIT);
                
                glBegin (GL_TRIANGLES);
                        glIndexi (0);
                        glColor3f (1.0f, 0.0f, 0.0f);
                        glVertex2i (0, 1);
                        glIndexi (0);
                        glColor3f (0.0f, 1.0f, 0.0f);
                        glVertex2i (-1, -1);
                        glIndexi (0);
                        glColor3f (0.0f, 0.0f, 1.0f);
                        glVertex2i (1, -1);
                glEnd ();

                if (gldrawable.is_double_buffered ())
                        gldrawable.swap_buffers ();
                else
                        glFlush ();

                gldrawable.gl_end ();
                return true;
        }

        construct
        {
                title = "simple";
                set_reallocate_redraws (true);
                destroy += Gtk.main_quit;
                
                Gdk.GL.Config glconfig = new Gdk.GL.Config.by_mode (Gdk.GL.ConfigMode.RGB | Gdk.GL.ConfigMode.DOUBLE);
                
                DrawingArea drawing_area = new DrawingArea ();
                drawing_area.set_size_request (200, 200);

                Gtk.GL.GtkWidgetExtension.set_gl_capability (drawing_area, glconfig, null, true, Gdk.GL.RenderType.RGBA_TYPE);
                
                drawing_area.configure_event += on_configure_event;
                drawing_area.expose_event += on_expose_event;
                
                add (drawing_area);
        }

        public static void main (string[] args)
        {
                Gtk.init (ref args);
                Gtk.GL.init (ref args);
                
                var simple = new Simple ();
                simple.show_all ();
                
                Gtk.main ();
        }
}

